                AREA text, CODE, READONLY
                CODE16

bl_dkg_init_loader
                PUSH    {R7,LR}
                LDR     R0, =0x24852000
                LDRH    R0, [R0,#0x14]
                MOV     R1, #1
                ORR     R0, R1
                LDR     R1, =0x24852000
                STRH    R0, [R1,#0x14]
                BL      init_main
                BL      flash_addrs_open_for_writes
                POP     {R7}
                POP     {R3}
                BX      R3
; End of function bl_dkg_init_loader


init_main
                PUSH    {R7,LR}
                BL      gpio_init
                BL      qspi_init
                BL      setup_Atlas_regulator
                BL      is_Atlas_init_needed
                CMP     R0, #0
                BEQ     loc_1000562C
                MOV     R3, #0          ; BPFET high, BATTFET low
                MOV     R2, #1          ; len 1
                MOV     R1, #0xB        ; GETCTRL
                MOV     R0, #0x30       ; Charger
                BL      hxCAPwrite
                MOV     R3, #1          ; Control by FETCTRL
                MOV     R2, #1          ; len 1
                MOV     R1, #0xA        ; FETOVRD
                MOV     R0, #0x30       ; Charger
                BL      hxCAPwrite
                B       loc_10005630
; 

loc_1000562C
                BL      ATLAS_Setup_USB_n_Charger_ports

loc_10005630
                BL      init_RTC
                POP     {R7}
                POP     {R3}
                BX      R3
; End of function init_main


gpio_init
                PUSH    {R7,LR}
                BL      hapi_gpio_init
                MOV     R3, #4
                MOV     R2, #1
                MOV     R1, #2
                MOV     R0, #2
                BL      HAPI_GPIO_config
                POP     {R7}
                POP     {R3}
                BX      R3
; End of function gpio_init


hapi_gpio_init
                LDR     R0, =0x5173
                LDR     R1, =0x24841000
                STR     R0, [R1,#8]
                LDR     R0, =0x2022002
                STR     R0, [R1]
                MOV     R0, #1
                LSL     R0, R0, #0xD
                STR     R0, [R1,#4]
                LDR     R0, =0x80001020
                STR     R0, [R1,#0x14]
                LSR     R0, R0, #0x13
                ADD     R1, #0x80
                STR     R0, [R1]
                LDR     R0, =0xFEA4
                SUB     R1, #0x80
                STR     R0, [R1,#0x20]
                LDR     R0, =0x10410000
                STR     R0, [R1,#0x18]
                LDR     R0, =0x12492
                STR     R0, [R1,#0x1C]
                LDR     R0, =0x44402
                STR     R0, [R1,#0x2C]
                MOV     R0, #4
                ADD     R1, #0x80
                STR     R0, [R1,#4]
                LDR     R0, =0xD007
                SUB     R1, #0x80
                STR     R0, [R1,#0x38]
                MOV     R0, #0x90
                STR     R0, [R1,#0x30]
                LDR     R0, =0x28140
                STR     R0, [R1,#0x34]
                MOV     R0, #0
                STR     R0, [R1,#0x44]
                MOV     R0, #2
                ADD     R1, #0x80
                STR     R0, [R1,#8]
                LDR     R0, =0xC66F
                SUB     R1, #0x80
                STR     R0, [R1,#0x50]
                LDR     R0, =0x10010492
                STR     R0, [R1,#0x48]
                LDR     R0, =0x12002
                STR     R0, [R1,#0x4C]
                MOV     R0, #0
                STR     R0, [R1,#0x5C]
                MOV     R0, #0x40
                ADD     R1, #0x80
                STR     R0, [R1,#0xC]
                LDR     R0, =0x33FA
                SUB     R1, #0x80
                STR     R0, [R1,#0x68]
                LDR     R0, =0x12492000
                STR     R0, [R1,#0x60]
                MOV     R0, #1
                LSL     R0, R0, #0xA
                STR     R0, [R1,#0x64]
                LDR     R0, =0xFFF31
                STR     R0, [R1,#0x74]
                LDR     R0, =0x1008
                ADD     R1, #0x80
                STR     R0, [R1,#0x10]
                LSR     R0, R0, #4
                STR     R0, [R1,#0x14]
                BX      LR
; End of function hapi_gpio_init


qspi_init
                PUSH    {R7,LR}
                MOV     R0, #4
                LDR     R1, =0x24851000
                STRH    R0, [R1]
                MOV     R0, #0
                STRH    R0, [R1,#2]
                STRH    R0, [R1,#4]
                STRH    R0, [R1,#8]
                STRH    R0, [R1,#0xA]
                STRH    R0, [R1,#0xC]
                STRH    R0, [R1,#0x10]
                MVN     R0, R0
                STRH    R0, [R1,#0xE]
                MOV     R0, #0
                STRH    R0, [R1,#0x16]
                STRH    R0, [R1,#0x18]
                STRH    R0, [R1,#0x1A]
                STRH    R0, [R1,#0x1C]
                STRH    R0, [R1,#0x1E]
                STRH    R0, [R1,#0x20]
                MOV     R0, #0x21
                STRH    R0, [R1,#0x36]
                MOV     R0, #0x81
                STRH    R0, [R1,#0x38]
                MOV     R3, #2
                MOV     R2, #1
                MOV     R1, #6
                MOV     R0, #3
                BL      HAPI_GPIO_config
                MOV     R0, #4
                LDR     R1, =0x24851000
                ADD     R1, #0x40
                STRH    R0, [R1,#2]
                MOV     R0, #0x81
                STRH    R0, [R1,#4]
                MOV     R0, #4
                SUB     R1, #0x40
                STRH    R0, [R1,#0x2A]
                MOV     R0, #0
                STRH    R0, [R1,#0x2C]
                MOV     R2, #1
                LSL     R2, R2, #0xA
                ADD     R1, R1, R2
                STRH    R0, [R1]
                LDR     R1, =0x24851000
                ADD     R1, R1, R2
                STRH    R0, [R1,#2]
                LDR     R0, =0x24851000
                LDRH    R0, [R0,#0x1A]
                MOV     R1, #1
                ORR     R0, R1
                LDR     R1, =0x24851000
                STRH    R0, [R1,#0x1A]
                MOV     R0, #0
                STRH    R0, [R1]
                POP     {R7}
                POP     {R3}
                BX      R3
; End of function qspi_init

                LTORG

setup_Atlas_regulator
                PUSH    {R7,LR}
                LDR     R3, =0x3820000D
                MOV     R2, #0x18
                MOV     R1, #0
                MOV     R0, #0x1C       ; Switchers 4 port
                BL      hxCAPwrite
                LDR     R3, =0x3AB00000
                MOV     R2, #0x18
                MOV     R1, #0
                MOV     R0, #0x1D       ; Switchers 5
                BL      hxCAPwrite
                LDR     R3, =0x3C024A34
                MOV     R2, #0x18
                MOV     R1, #0
                MOV     R0, #0x1E       ; Regulator setting 0
                BL      hxCAPwrite
                LDR     R3, =0x3E000287
                MOV     R2, #0x18
                MOV     R1, #0
                MOV     R0, #0x1F       ; Regulator setting 1
                BL      hxCAPwrite
                LDR     R3, =0x401C01FF
                MOV     R2, #0x18
                MOV     R1, #0
                MOV     R0, #0x20       ; Regulator mode 0
                BL      hxCAPwrite
                LDR     R3, =0x42E071C1
                MOV     R2, #0x18
                MOV     R1, #0
                MOV     R0, #0x21       ; Regulator mode 1
                BL      hxCAPwrite
                POP     {R7}
                POP     {R3}
                BX      R3
; End of function setup_Atlas_regulator


hxCAPwrite
                PUSH    {R0-R7,LR}
                SUB     SP, SP, #4
                ADD     R7, R0, #0
                ADD     R5, R1, #0
                ADD     R6, R2, #0
                MOV     R4, #0
                MVN     R4, R4
                LSR     R4, R5
                MOV     R0, #0x20
                SUB     R0, R0, R6
                LSL     R4, R0
                ADD     R0, R5, R6
                MOV     R1, #0x20
                SUB     R0, R1, R0
                LSR     R4, R0
                MOV     R2, #0x18
                MOV     R1, #0
                ADD     R0, R7, #0
                BL      hxCAPread
                STR     R0, [SP]
                LDR     R0, [SP]
                BIC     R0, R4
                STR     R0, [SP]
                MOV     R1, #0x3F
                LSL     R1, R1, #0x19
                LDR     R0, [SP]
                BIC     R0, R1
                STR     R0, [SP]
                LSL     R1, R7, #0x19
                MOV     R0, #0x3F
                LSL     R0, R0, #0x19
                AND     R1, R0
                LDR     R0, [SP,#0x10]
                LSL     R0, R5
                AND     R0, R4
                ORR     R0, R1
                LDR     R1, [SP]
                ORR     R0, R1
                MOV     R1, #1
                LSL     R1, R1, #0x1F
                ORR     R0, R1
                STR     R0, [SP]
                MOV     R3, #4
                MOV     R2, #0
                MOV     R1, SP
                MOV     R0, #3
                BL      qspi_io
                ADD     SP, SP, #0x14
                POP     {R4-R7}
                POP     {R3}
                BX      R3
; End of function hxCAPwrite


hxCAPread
                PUSH    {R3-R7,LR}
                ADD     R7, R0, #0
                ADD     R5, R1, #0
                ADD     R6, R2, #0
                MOV     R4, #0
                MVN     R4, R4
                LSR     R4, R5
                MOV     R0, #0x20
                SUB     R0, R0, R6
                LSL     R4, R0
                ADD     R0, R5, R6
                MOV     R1, #0x20
                SUB     R0, R1, R0
                LSR     R4, R0
                LSL     R0, R7, #0x19
                STR     R0, [SP]
                MOV     R3, #4
                MOV     R2, SP
                MOV     R1, SP
                MOV     R0, #3
                BL      qspi_io
                LDR     R0, [SP]
                AND     R0, R4
                LSR     R0, R5
                POP     {R3-R7}
                POP     {R3}
                BX      R3
; End of function hxCAPread


qspi_io
                PUSH    {R4-R7}
                LSL     R5, R0, #0x1C
                LSR     R5, R5, #0x1C
                SUB     R6, R3, #1
                LSL     R6, R6, #4
                MOV     R7, #0xFF
                ADD     R7, #0xF1
                AND     R6, R7
                ORR     R5, R6
                LDR     R6, =0x24851000
                MOV     R7, #1
                LSL     R7, R7, #0xA
                ADD     R6, R6, R7
                STRH    R5, [R6,#4]
                CMP     R0, #0
                BNE     loc_10006306
                MOV     R5, #3
                LDR     R6, =0x24851000
                STRH    R5, [R6,#0xC]
                B       loc_1000630C
; 

loc_10006306
                MOV     R5, #0
                LDR     R6, =0x24851000
                STRH    R5, [R6,#0xC]

loc_1000630C
                LSL     R5, R3, #0x1F
                BPL     loc_10006316
                ADD     R5, R3, #1
                LSL     R3, R5, #0x10
                LSR     R3, R3, #0x10

loc_10006316
                MOV     R4, #0

loc_10006318
                LSR     R5, R3, #1
                CMP     R5, R4
                BLS     loc_1000633C
                B       loc_10006328
; 

loc_10006320
                ADD     R5, R4, #1
                LSL     R4, R5, #0x10
                LSR     R4, R4, #0x10
                B       loc_10006318
; 

loc_10006328
                LSL     R5, R4, #1
                LDRH    R5, [R1,R5]
                LSL     R6, R4, #1
                LDR     R7, =0x24851000
                ADD     R6, R6, R7
                MOV     R7, #0x13
                LSL     R7, R7, #6
                ADD     R6, R6, R7
                STRH    R5, [R6]
                B       loc_10006320
; 

loc_1000633C
                MOV     R5, #1
                LDR     R6, =0x24851000
                STRH    R5, [R6,#0x12]
                MOV     R5, #0x20
                STRH    R5, [R6,#6]

loc_10006348
                LDR     R5, =0x24851000
                LDRH    R5, [R5,#0x12]
                LSL     R5, R5, #0x1F
                BMI     loc_10006352
                B       loc_10006348
; 

loc_10006352
                CMP     R2, #0
                BEQ     loc_1000637C
                MOV     R4, #0

loc_10006358
                LSR     R5, R3, #1
                CMP     R5, R4
                BLS     loc_1000637C
                B       loc_10006368
; 

loc_10006360
                ADD     R5, R4, #1
                LSL     R4, R5, #0x10
                LSR     R4, R4, #0x10
                B       loc_10006358
; 

loc_10006368
                LSL     R5, R4, #1
                LDR     R6, =0x24851000
                ADD     R5, R5, R6
                MOV     R6, #0x13
                LSL     R6, R6, #6
                ADD     R5, R5, R6
                LDRH    R5, [R5]
                LSL     R6, R4, #1
                STRH    R5, [R2,R6]
                B       loc_10006360
; 

loc_1000637C
                POP     {R4-R7}
                BX      LR
; End of function qspi_io


is_Atlas_init_needed
                PUSH    {R7,LR}
                MOV     R2, #1
                MOV     R1, #0x13
                MOV     R0, #2
                BL      hxCAPread
                CMP     R0, #0
                BNE     loc_100055D8
                MOV     R2, #1
                MOV     R1, #0x11
                MOV     R0, #2
                BL      hxCAPread
                CMP     R0, #1
                BNE     loc_100055D8
                B       loc_100055DA
; 

loc_100055D8
                MOV     R0, #0

loc_100055DA
                LSL     R0, R0, #0x18
                LSR     R0, R0, #0x18
                POP     {R7}
                POP     {R3}
                BX      R3
; End of function is_Atlas_init_needed


ATLAS_Setup_USB_n_Charger_ports
                PUSH    {R7,LR}
                MOV     R3, #1          ; =1 -> BPFET high, BATTFET low
                MOV     R2, #1          ; len 1
                MOV     R1, #0xB        ; FetCtrl - BPFET/BATTFET
                MOV     R0, #0x30       ; Charger port
                BL      hxCAPwrite
                MOV     R3, #1          ; =1 -> Control by FETCTRL
                MOV     R2, #1          ; len 1
                MOV     R1, #0xA        ; FETOVRD - select control by feature instead of hw
                MOV     R0, #0x30       ; Charger port
                BL      hxCAPwrite
                MOV     R3, #1          ; =01
                MOV     R2, #2          ; len 2
                MOV     R1, #0          ; VUSBIN
                MOV     R0, #0x32       ; Charger/USB port1
                BL      hxCAPwrite
                MOV     R3, #1          ; =1 -> 3.3 V
                MOV     R2, #1          ; len 1
                MOV     R1, #2          ; VUSB
                MOV     R0, #0x32       ; Charger/USB port1
                BL      hxCAPwrite
                MOV     R3, #1          ; =1 -> ON
                MOV     R2, #1          ; len 1
                MOV     R1, #3          ; VUSBEN
                MOV     R0, #0x32       ; Charger/USB port1
                BL      hxCAPwrite
                MOV     R3, #1          ; =1
                MOV     R2, #1          ; len 1
                MOV     R1, #0xC        ; USBXCVREN
                MOV     R0, #0x31       ; USB Port0
                BL      hxCAPwrite
                POP     {R7}
                POP     {R3}
                BX      R3
; End of function ATLAS_Setup_USB_n_Charger_ports


init_RTC
                LDR     R0, =0x24843000
                LDR     R0, [R0]
                MOV     R1, #0x80       ; bit7 - pwrcut enable
                ORR     R0, R1
                LDR     R1, =0x24843000
                STR     R0, [R1]
                ADD     R0, R1, #0
                LDR     R0, [R0]
                MOV     R1, #0xFF       ; set modulus to max
                LSL     R1, R1, #8
                ORR     R0, R1
                LDR     R1, =0x24843000
                STR     R0, [R1]
                BX      LR
; End of function init_RTC


flash_addrs_open_for_writes
                LDR     R0, =0x28880000
                LDR     R0, [R0,#0x10]
                MOV     R1, #0x10
                BIC     R0, R1
                LDR     R1, =0x28880000
                STR     R0, [R1,#0x10]
                ADD     R0, R1, #0
                LDR     R0, [R0,#0x20]
                MOV     R1, #0x10
                BIC     R0, R1
                LDR     R1, =0x28880000
                STR     R0, [R1,#0x20]
                BX      LR
; End of function flash_addrs_open_for_writes

                LTORG

                end


